#A class file imported to other files
# Get string stuff
from string import split, atoi, join
#
# We want to work with the postgres db
import pgdb


def dbbool(num):
    if (num != 0): return "true"
    else:
        return "false"
    
class LogClass:
 
    def __init__(self, LogEntry):
        """ Initialize with a Log Entry"""
        self.chgEntries(LogEntry)
        self.insertInTable()

    def insertInTable(self):
        """ Use the Pydb modules to insert into the postgres table"""
        theDB=pgdb.connect(dsn="farimir:fwlogs", user="postgres", database="fwlogs")
        insCursor=theDB.cursor()
        sqlstatement = """insert into logs (entry,  host, interface, inPacket, protocol,
        FromIP ,FromPort,  ToIP, ToPort, Length, S, I, F, T, Syn, ending)
        VALUES ('%s', '%s', '%s', %s, %d, '%s', %d,  '%s', %d, %d, '%s', %d,
        '%s', %d, %s, '%s');"""%(self.EntryDate, self.host, self.interface, dbbool(self.inPacket),
                                 self.protocol, self.FromIP, self.FromPort, self.ToIP, self.ToPort, self.Length,self.S, self.I, self.F,
                                 self.T, dbbool(self.Syn), self.ending)
        insCursor.execute(sqlstatement)
        theDB.commit()

        
        

    def chgEntries(self, LogEntry):
        self.EntryDate=LogEntry[:15] + " 2001 MDT"
        items=split(LogEntry[15:]);
        self.host=items[0];
        self.interface=items[6];
        self.inPacket=("input" == items[4])
        self.protocol=atoi(split(items[7],'=')[1])
        attacker=split(items[8],':')
        self.FromIP=attacker[0];
        self.FromPort=atoi(attacker[1]);
        defender=split(items[9],':')
        self.ToIP=defender[0];
        self.ToPort=atoi(defender[1]);
        self.Length=atoi(split(items[10],'=')[1])
        self.S=split(items[11],'=')[1]
        self.I=atoi(split(items[12],'=')[1])
        self.F=split(items[13],'=')[1]
        self.T=atoi(split(items[14],'=')[1])
        self.Syn=("SYN"==items[15])
        if self.Syn:
            self.ending=join(items[16:])
        else:
            self.ending=join(items[15:])
        
    def __repr__(self):
        return self.EntryDate + " " + self.host + " " +self.interface  + " " +self.FromIP  + " " +self.S+ " " + self.ending
    #+ " " +self.inPacket
        
        
    
