#!/usr/bin/python
#
#  Title:   sortedattacks
#  Date:    June 2001
#  Authour: Brett Giles
#  Used by: 
#  Uses:    None
#  Purpose: Displays Modules  as selected by the client

import sys
import traceback
import string

import pgdb
import cgi


from wutils import bpreqhtml
from wutils.bpreqhtml import bail
def sortedattacks():
    sys.stderr = sys.stdout

    # Set Up Page Layout
    page = bpreqhtml.page(title='FireMUROS - Whose hittin on ya')
    body=page.body()

    sqlString="""select Interface, FromIP, ToPort, count(*) from logs
    group by Interface, FromIP, ToPort
    order by 1,4 desc"""

    try:
        # PgSQL configuration:
        theDB=pgdb.connect(dsn="farimir:fwlogs", user="postgres", database="fwlogs")
        
        cursor = theDB.cursor()
        cursor.execute(sqlString)
        resultSet = cursor.fetchall()
    except:
        bail(body,page)

    body.head('Attacks! Table', 2)

    mtab = body.table()
    titlerow=[]
    for cursorFieldname in cursor.description:
        titlerow.append(cursorFieldname[0])
    mtab.row(elements=titlerow,centre='yes')

    for cursorRecord in resultSet:
        cursorRecord[1] = """<form action=http://www.arin.net/cgi-bin/whois.pl method=post>
        <input name=queryinput type=hidden value=%s>
        <input name=B1 type=submit value=%s>
        </form>"""%(cursorRecord[1],cursorRecord[1])
        mtab.row(elements=cursorRecord)
    del(mtab)


    try:
        theDB.close()
    except:
        bail(body, page)

    del(body)
    del(page)
    return

sortedattacks()
