#!/usr/bin/python
# A beginning class for html writing. 
import traceback
import sys

def bail(*elements):
   print '\n\n<pre>'
   traceback.print_exc()
   for obj in elements:
       del(obj)
   sys.exit()

def makejump(item,location):
   return '<a href="%s">%s</a>'%(location, item)


class page:

    def __init__(self, title='',stylesheet=''):
	print 'content-type: text/html'
	print 
#	print '<!doctype html public "-//w3c//dtd html 4.0//en">'
        print '<html>\n'
	print '<head>'
	if stylesheet != '' :
	    print '<link rel="stylesheet" href="%s" type="text/css">'%stylesheet
	print '<title>', title
	print '</title></head>'


    def __del__(self):
	print "</html>\n"

    class body:


	def __init__(self, bgcolor='#bba5dd'):
	    print '<body bgcolor="%s">'%bgcolor

	def __del__(self):
	    print ("</body>")
    
	def para(self,thetext, font=''):
	    print '<p>'
	    if len(font) > 0:
		print '<font %s>'%(font)
	    print thetext
	    if len(font) > 0:
		print '</font>'
	    print '</p>'
	
	def head(self,thetext,level=1):
	    print '<h%1d>'%level
	    print thetext
	    print '</h%1d>'%level
	
	def textbreak(self,thetext,font='',br='after'):
	    if len(font) > 0:
		print '<font %s>'%(font)
	    if br == 'after':
		print thetext, '<br />'
	    else:
		if br == 'both':
		    print '<br />%s<br />'%thetext
		else:
		    print '<br />%s'%thetext
	    if len(font) > 0:
		print '</font>'
	
	def jump(self,location,text):
	    print '<a href="%s">%s</a>'%(location, text)


    
        class table:
	    def __init__(self, border='1', font='',centre='no'):
		print '<table border="%s">'%border
		self.font=font
		self.centre=centre
		if centre == 'yes': print '<center>'
		if len(font) > 0:
		    print '<font %s>'%(font)

	
	    def row(self, elements=[], font='', centre='no'):
		print '<tr>'
		if centre =='yes': print '<center>'
	    	#print 'font = ', font
		if len(font) > 0:
		    print '<font %s>'%(font)
		for rowelement in elements:
		    print '<td>', rowelement,'</td>'
		if len(font) > 0:
		    print '</font>'
		if centre =='yes': print '</center>'
		print '</tr>'
    
	    def __del__(self):
		if len(self.font) > 0:
		    print '</font>'
		if self.centre == 'yes': print '</center>'
		print '</table>'

	class form:
	    def __init__(self, action='', method='POST', submit='Submit', reset=''):
		self.submit=submit
		self.reset=reset
		print '<form action="%s" method="%s">'%(action,method)

	    def __del__(self):
		print '<input type="submit" name="%s" value="%s">'%(self.submit, self.submit)
		if self.reset != '':
		    print '<input type="reset" name="%s" value="%s">'%(self.reset, self.reset)
		print '</form>'
	    def textarea(self,name, rows=2, cols=30, value=''):
		print '<textarea name="%s" rows="%d" cols="%d" wrap>'%(name,rows,cols)
		print value
		print '</textarea>'

	    def text(self,name,size=60, maxlen=60, value=''):
		print '<input type="text" name="%s" size="%d" maxlength="%d" value="%s">'%(name,
			size, maxlen, value)
	    def checkbox(self,name, value='',curval=''):
		print '<input type="checkbox" name="%s" value="%s" '%(name, value),
		if value ==curval:
		    print ' checked >'
		else:
		    print '>'

  
	    
	    def hidden(self, name, value=''):
		print '<input type="hidden" name="%s" value="%s">'%(name,value)
	    
	    class selectbox:
		def __init__(self, name, size='', multiple=''):
		    psize=pmultiple=''
		    if size != '': psize='size="%s"'%size
		    if multiple != '': pmultiple = 'multiple'
		    print '<select name="%s" %s %s>'%(name,psize,pmultiple)
	    
		def __del__(self):
		    print '</select>'
	
		def option(self, value,selected, sep, *displayed):
		    if selected == '' :
			print '<option value="%s">'%value
		    else:
			print '<option value="%s" selected>'%value
		    count = len(displayed)
		    i = 1
		    for item in displayed : 
			print item,
			if i != count:
			    i = i + 1
			    print sep



	


if __name__ == "__main__":

  whosit=page(title="The page Title");
  whatsit=body();
  tw=table()
  tw.row('a', 'b', 'c')
  tw.row(1,2,3)
  del(tw)
  del(whatsit)

